////////////////////////////////////////////////////////////////////////////
// Model: Kyvadlo2.CPP
//

#include "simlib.h"
#include <iostream.h>
#include <fstream.h>

const double g = 9.81;
double L = 1;

// popis systmu:   x'' +  omega^2 * sin(x) = 0,  omega^2 = g/L
struct Kyvadlo {
  Parameter L;
  Integrator x,x1;
  Kyvadlo(double l):
    L(l),
    x1( -0.05*x1 - g/L * Sin(x) ),
    x( x1 ) { }
  void PrintParameters() { 
     cout << "# L = " << L.Value();
     cout << ", x0 = " << x.Value() << ", y0 = " << x1.Value() << "\n"; 
  }
};

Kyvadlo k(L);

// sledovn stavu modelu ...
void Sample() { 
  cout << Time << ' ' << k.x.Value() << ' ' << k.x1.Value() << "\n"; 
}
Sampler S(Sample, 0.1);

// popis experimentu ...
main() {
  cout << "# Kyvadlo \n";
  ifstream f("kyvadlo2.in");
  if(!f) { cerr << "soubor KYVADLO2.IN neexistuje"; return 0; }
  f >> L; 
  k.L = L;
  cerr << "Model kyvadla \nL = " << L << "\n";
  while(1)
  {
    double x,y,t;
    f >> x >> y >> t;
    if(!f) break;
    cerr << "x0 = " << x << ",  \t y0 = " << y << "\n";
    k.x.Init(x);                    // nastav po. hodnotu
    k.x1.Init(y);                    
    cout << "\n";                   // oddl vstupy
    k.PrintParameters();
    Init(0,t);                      // inicializace parametr experimentu
    Run();                          // simulace
  }
  cout << "# konec \n";
  return 0;
}


