/////////////////////////////////////////////////////////////////////////////
//! \file event.cc   Discrete events base class
//
// Copyright (c) 1991-2004 Petr Peringer 
//
// This library is licensed under GNU Library GPL. See the file COPYING.
//

//
// description: implementation of class Event
//

////////////////////////////////////////////////////////////////////////////
// interface
//

#include "simlib.h"
#include "internal.h"

////////////////////////////////////////////////////////////////////////////
// implementation
//

namespace simlib3 {

SIMLIB_IMPLEMENTATION;

////////////////////////////////////////////////////////////////////////////
//  constructor
//
Event::Event(Priority_t p) : Entity(p)
{
  Dprintf(("Event::Event(%u)", p));
}

////////////////////////////////////////////////////////////////////////////
//  destructor
//
Event::~Event()
{
  Dprintf(("Event::~Event()", Name()));
}

////////////////////////////////////////////////////////////////////////////
//  _Run() - activation method
//
void Event::_Run() throw()
{
  Behavior();
  if(Idle()) // not scheduled
      Terminate();
}

////////////////////////////////////////////////////////////////////////////
// Event::Name
//
const char *Event::Name() const
{
    const char *name = SimObject::Name();
    if(*name) return name; // has explicit name
    else      return SIMLIB_create_name("Event#%lu", _Ident);
}

}
// end
